import React, { useState, useEffect } from "react";
import { useSelector, useDispatch } from "react-redux";
import Input from "./Input";
import Output from "./Output";

function App() {
  const [seconds, setSeconds] = useState(0);
  const textLength = useSelector((state) => state.textLength);
  const dispatch = useDispatch();

  useEffect(() => {
    const startTime = Date.now();

    const id = setInterval(() => {
      const timeDiffInSeconds = (Date.now() - startTime) / 1000;
      const roundedSeconds = Math.floor(timeDiffInSeconds);
      setSeconds(roundedSeconds);
    }, 1000);

    return () => clearInterval(id);
  }, []);

  useEffect(() => {
    if (seconds > 0) {
      const avgCharsPerSecond = textLength / seconds;
      dispatch({
        type: "setAvgCharsPerSecond",
        payload: avgCharsPerSecond,
      });
    }
  }, [seconds, textLength, dispatch]);

  return (
    <div className="App">
      <Input />
      <Output passedSeconds={seconds} />
    </div>
  );
}

export default App;
